﻿using SfDataGrid_ComboBoxDemo;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SfDataGrid_ComboBoxDemo
{
    /// <summary>
    /// 
    /// </summary>
    public class ViewModel : INotifyPropertyChanged
    {       
        private ObservableCollection<OrderInfo> _orderList;
        public ObservableCollection<OrderInfo> OrderList
        {
            get
            {
                return _orderList;
            }
            set
            {
                _orderList = value;
                RaisePropertyChanged("OrderList");
            }
        }

        Dictionary<string, ObservableCollection<CityDetails>> _shipCities;
        public Dictionary<string, ObservableCollection<CityDetails>> ShipCities
        {
            get
            {
                return _shipCities;
            }
            set
            {
                _shipCities = value;
            }
        }

        public List<string> CountryList { get; set; }

        public ViewModel()
        {
            this.Generate();
            _shipCities = CountryDetailsRepository.GetCityDetails();
            CountryList = CountryDetailsRepository.GetCountryList();
        }

        public void Generate()
        {
            _orderList = new ObservableCollection<OrderInfo>();
            _orderList.Add(new OrderInfo() { ProductId = 1001, ProductName = "Alice Mutton", NoOfOrders = 10, OrderDate = new DateTime(2015, 5, 2), CountryName = "Argentina", CityID = 114 });
            _orderList.Add(new OrderInfo() { ProductId = 1002, ProductName = "NuNuCa Nuß-Nougat-Creme", NoOfOrders = 10, OrderDate = new DateTime(2015, 5, 20), CountryName = "Austria", CityID = 102 });
            _orderList.Add(new OrderInfo() { ProductId = 1003, ProductName = "Boston Crab Meat", NoOfOrders = 100, OrderDate = new DateTime(2015, 5, 3), CountryName = "Belgium", CityID = 108 });
            _orderList.Add(new OrderInfo() { ProductId = 1004, ProductName = "Konbu", NoOfOrders = 50, OrderDate = new DateTime(2015, 5, 13), CountryName = "Brazil", CityID = 103 });
            _orderList.Add(new OrderInfo() { ProductId = 1005, ProductName = "Boston Crab Meat", NoOfOrders = 20, OrderDate = new DateTime(2015, 5, 23), CountryName = "Canada", CityID = 104 });
            _orderList.Add(new OrderInfo() { ProductId = 1006, ProductName = "Raclette Courdavault", NoOfOrders = 20, OrderDate = new DateTime(2015, 5, 13), CountryName = "Denmark", CityID = 107 });
            _orderList.Add(new OrderInfo() { ProductId = 1007, ProductName = "Wimmers gute Semmelknödel", NoOfOrders = 20, OrderDate = new DateTime(2015, 5, 13), CountryName = "Finland", CityID = 113 });
            _orderList.Add(new OrderInfo() { ProductId = 1005, ProductName = "Boston Crab Meat", NoOfOrders = 25, OrderDate = new DateTime(2015, 1, 23), CountryName = "Italy", CityID = 104 });
            _orderList.Add(new OrderInfo() { ProductId = 1006, ProductName = "Raclette Courdavault", NoOfOrders = 24, OrderDate = new DateTime(2015, 4, 28), CountryName = "US", CityID = 107 });
            _orderList.Add(new OrderInfo() { ProductId = 1007, ProductName = "Wimmers gute Semmelknödel", NoOfOrders = 40, OrderDate = new DateTime(2015, 5, 8), CountryName = "UK", CityID = 113 });
           
        }

        public event PropertyChangedEventHandler PropertyChanged;
        public void RaisePropertyChanged(string propName)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(propName));
        }
    }
}
